package de.donmanfred;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import org.xmlpull.v1.XmlPullParser;

import com.github.gcacace.signaturepad.views.SignaturePad;
import com.github.gcacace.signaturepad.views.SignaturePad.OnSignedListener;

import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.net.Uri;
import android.os.Environment;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;

@Version(0.21f)
@ShortName("SignPad")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
@Events(values={"onSigned(sign As Object)"})
//@DependsOn(values={"android-viewbadger"})
public class SignPad extends ViewWrapper<SignaturePad>  implements DesignerCustomView {
	private BA ba;
	private String eventName;
  //private SignaturePad mSignaturePad;
	
	
	/*
	 * Initialize the signPad and starts a Signature-capturing.	 * 
	 */   	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		AttributeSet myAttributes = null;
		this.setObject(new SignaturePad(ba.context, myAttributes));
		Capture(true);
 	}

	//programmatically add view
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		//AttributeSet attrs;		
		//XmlPullParser parser = Resources.getXml(myResouce);
		//AttributeSet myAttributes = Xml.asAttributeSet(parser);
		//AttributeSet myAttributes = null;
		//anywheresoftware.b4a.		 
		//mSignaturePad = new SignaturePad(ba.context, myAttributes);
		Parent.addView(this.getObject(), new BALayout.LayoutParams(left, top, width, height));
	}
	
	/*
	 * Starts a new Signature-capture 
	 */   	
	public void Capture(boolean ContinueAfterSign){
		OnSignedListener listener = new SignaturePad.OnSignedListener() {
			@SuppressWarnings("static-access")
			@Override
      public void onSigned() {
      	//ba.Log("onSigned() event");
				Bitmap bmp = getObject().getTransparentSignatureBitmap();
      	//ba.Log("bmp ready. raising event");
      	//ba.raiseEventFromUI(this, eventName + "_onsigned", {(Bitmap) bmp});
				ba.raiseEvent(this, eventName + "_onsigned", (Bitmap) bmp);
				//mSaveButton.setEnabled(true);
          //mClearButton.setEnabled(true);
			}

      @Override
      public void onClear() {
      	ba.Log("onClear() event");
          //mSaveButton.setEnabled(false);
          //mClearButton.setEnabled(false);
      }
    };
    this.getObject().setOnSignedListener(listener);
    
    
    this.getObject().setOnTouchListener(new OnTouchListener(){

			@Override
			public boolean onTouch(View arg0, MotionEvent arg1) {
				// TODO Auto-generated method stub
				return false;
			}});
	}
	
	

	//this method cannot be hidden.
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)this.getObject().getLayoutParams();
		lp.left = left;
		this.getObject().getParent().requestLayout();
	}
	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)this.getObject().getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)this.getObject().getLayoutParams();
		lp.top = top;
		this.getObject().getParent().requestLayout();
	}
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)this.getObject().getLayoutParams();
		return lp.top;
	}
  
	public void clear()	{
		this.getObject().clear();
	}
	
	public Bitmap getSignatureBitmap(){
		return this.getObject().getSignatureBitmap();
	}
	
  public Bitmap getTransparentSignatureBitmap() {
    return this.getObject().getTransparentSignatureBitmap();
  }
	
	
	public File getAlbumStorageDir(String albumName) {
    // Get the directory for the user's public pictures directory.
    File file = new File(Environment.getExternalStoragePublicDirectory(
            Environment.DIRECTORY_PICTURES), albumName);
    if (!file.mkdirs()) {
    	BA.Log("SignaturePad: Directory not created");
    }
    return file;
  }
	
	public float getStrokeWidth() {
		return this.getObject().getStrokeWidth();
	}

	public void setStrokeWidth(float StrokeWidth) {
		this.getObject().setStrokeWidth(StrokeWidth);
	}

	public void saveBitmapToJPG(Bitmap bitmap, String filename) throws IOException {
  ba.Log("Writing "+filename);
	File f = new File(filename);    
  Bitmap newBitmap = Bitmap.createBitmap(bitmap.getWidth(), bitmap.getHeight(), Bitmap.Config.ARGB_8888);
  Canvas canvas = new Canvas(newBitmap);
  canvas.drawColor(Color.WHITE);
  canvas.drawBitmap(bitmap, 0, 0, null);
  OutputStream stream = new FileOutputStream(f);
  newBitmap.compress(Bitmap.CompressFormat.JPEG, 100, stream);
  stream.close();
}


	
}
